BMapCom.Controller.create(function() {

    var $ = function(q) {
        return document.querySelector(q)
    };
    var $all = function(q) {
        return document.querySelectorAll(q)
    };

    var pageParamCache = {};

    var renderPage = function(commentDetailPage, commentDetailTpl) {
        commentDetailPage.append(commentDetailTpl.body());
    }

    var fixComment = function(review, sort) {
        if(review){
            var fixedData = {
                'showHead': true,
                'showSort': true,
                'showSeeMoreFoot': false,
                'showLoadMoreFoot': (ugcCommentSource.pageNum >= Math.floor(review.review_num / 10)) ? false : true,
                'title': review.cn_name || '',
                'total': review.review_num || 0,
                'comments': []
            }
            fixedData.sort = sort;
            fixedData.comments = review.info.map(function(commentItem) {
                commentItem.cn_name = review.cn_name;
                commentItem.username = commentItem.user_name || (commentItem.cn_name + '网友');
                commentItem.ratingLevel = (commentItem.rating) ? commentItem.rating * 20 + "%" : ((commentItem.overall_rating) ? commentItem.overall_rating * 20 + "%" : 0);
                commentItem.rating = (commentItem.rating) ? commentItem.rating : ((commentItem.overall_rating) ? commentItem.overall_rating : 0);
                if (commentItem.content.length > 50) {
                    commentItem.lessContent = commentItem.content.substr(0, 50) + '...';
                }
                return commentItem;
            });
            return fixedData;
        }
    }

    var commentView;

    var renderComment = function(commentDetailPage, commentDetailTpl, result) {

        var fixedData = fixComment(result.review, '默认排序');

        BMapCom.Plugin.use('CommentView').then(function(CommentView) {
            commentView = CommentView.instantiate(fixedData, $('.comment-container'));
            commentView.event.on('sortByDefault', function() {
                ugcCommentSource.pageNum = 0;
                ugcCommentSource.sort = 2;

                ugcCommentSource.update({
                    'uid': ugcCommentSource.uid,
                    'pageNum': 0,
                    'sort': 2,
                    'type': 'sortByDefaultPage'
                });
            });
            commentView.event.on('sortByTime', function() {
                ugcCommentSource.pageNum = 0;
                ugcCommentSource.sort = 1;

                ugcCommentSource.update({
                    'uid': ugcCommentSource.uid,
                    'pageNum': 0,
                    'sort': 1,
                    'type': 'sortByTimePage'
                });
            });
        });
        return;
    }

    var ugcCommentSourceDelegate = {
        search: function(uid, pageNum, sort, type) {
            var self = this;

            //http://client.map.baidu.com/phpui2/?t=1390209362250&resid=01&qt=ugccom&from=webview&uid=35debf299ac5515da6da3931&orderBy=2&maxResults=10&dataformat=json
            var domain = "http://client.map.baidu.com/phpui2/?"
            var param = [
                'qt=ugccom',
                'resid=01',
                'from=webview',
                'orderBy=' + sort,
                'startIndex=' + pageNum,
                'maxResults=10',
                'dataformat=json',
                'uid=' + uid
            ].join('&');
            var url = domain + param;


            return BMapCom.Loader.jsonp(url)
                .ok(function(result) {
                    if(result.data && result.data.review){
                        self.onSourceLoadFinish(result.data, type);
                    }
                    else{
                        unbindLoad(); 
                    }
                })
                .error(function() {
                    self.onSourceLoadFailed();
                });

        }
    };

    var evt;

    var bindPageEvent = function() {
        var evtAddComment = new BMapCom.EventDelegater($('#commentPageContent'));
        evtAddComment.on('addComment:tap/preventDefault', function(e) {
            BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, function(location) {
                var requestParam = {
                    "category": "mainmap",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "place_comment_edit_page",
                        "base_params": {
                            "uid": pageParamCache.uid,
                            "loc_x": location.locX,
                            "loc_y": location.locY,
                            "place_name": "scope",
                            "poi_name": pageParamCache.poiName
                        }
                    }
                };
                BMapCom.Kernel.notify('request', requestParam, function(result) {});
            });
        });
        if (!evt) {
            evt = new BMapCom.EventDelegater($('#ugcCommentContainer'));

            evt.on('loadMore:tap', function(e) {
                ugcCommentSource.update({
                    'uid': ugcCommentSource.uid,
                    'pageNum': ugcCommentSource.pageNum + 1,
                    'sort': ugcCommentSource.sort,
                    'type': 'nextPage'
                });
            });
        }
    };

    var unbindLoad = function(){
        $(".cv-load-more-foot").setAttribute("data-ek", "");
        $(".cv-load-more-foot").innerHTML = "";  
    };

    var ugcCommentSource;

    var initMethod = function(commentDetailPage, commentDetailTpl) {
        renderPage(commentDetailPage, commentDetailTpl);

        ugcCommentSource = new BMapCom.DataSource();
        ugcCommentSource
            .delegate(ugcCommentSourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result, type) {
                    switch (type) {
                        case 'firstPage':
                            renderComment(commentDetailPage, commentDetailTpl, result);
                            break;
                        case 'nextPage':
                            commentView.refresh(fixComment(result.review, this.sort));
                            break;
                        case 'sortByDefaultPage':
                            commentView.clear();
                            commentView.refresh(fixComment(result.review, this.sort));
                            break;
                        case 'sortByTimePage':
                            commentView.clear();
                            commentView.refresh(fixComment(result.review, this.sort));
                            break;
                        case 'refreshPage':
                            commentView.clear();
                            commentView.refresh(fixComment(result.review, this.sort));
                            break;
                    }
                    bindPageEvent();
                    BMapCom.Kernel.notify('webPageReady');
                },
                startSourceLoad: function(param) {
                    this.uid = param.uid;
                    this.pageNum = param.pageNum;
                    this.sort = param.sort;
                    this.type = param.type;
                    this.search(param.uid, param.pageNum, param.sort, param.type);
                }
            });
        commentDetailPage
            .delegate({
                shouldWaiting: function() {
                    return true;
                },
                onCreate: function(pageParam, ready) {
                    pageParamCache = pageParam;
                    ugcCommentSource.update({
                        'uid': pageParam.uid,
                        'pageNum': 0,
                        'sort': 2,
                        'type': 'firstPage'
                    });
                },
                onDestory: function() {
                    renderContainer.innerHTML = "";
                }
            });

        BMapCom.Kernel.listen('refresh', function() {
            ugcCommentSource.update({
                'uid': ugcCommentSource.uid,
                'pageNum': 0,
                'sort': ugcCommentSource.sort,
                'type': 'refreshPage'
            });
        });

    }


    return {
        initWithPage: initMethod
    }
});