BMapCom.Controller.create(function() {

    var $ = function(q) {
        return document.querySelector(q)
    };
    var $all = function(q) {
        return document.querySelectorAll(q)
    };

    var pageParamCache = {};

    var fixComment = function(reviewItem, sortValue) {
        var result = {
            'showHead': true,
            'showSort': reviewItem.name == 'baidumap',
            'showSeeMoreFoot': true,
            'showLoadMoreFoot': false,
            'title': reviewItem.cn_name || '',
            'name': reviewItem.name,
            'total': reviewItem.rivew_num || reviewItem.review_num || 0,
            'url': reviewItem.url_mobilephone,
            'comments': []
        };
        switch (sortValue) {
            case 2:
                result.sort = '默认排序';
                break;
            case 1:
                result.sort = '时间排序';
                break;
            default:
                result.sort = '默认排序';
        };

        result.comments = reviewItem.info.map(function(commentItem) {
            commentItem.cn_name = reviewItem.cn_name;
            commentItem.username = commentItem.user_name || (commentItem.cn_name + '网友');
            commentItem.ratingLevel = (commentItem.rating) ? commentItem.rating * 20 + "%" : ((commentItem.overall_rating) ? commentItem.overall_rating * 20 + "%" : 0);
            commentItem.rating = (commentItem.rating) ? commentItem.rating : ((commentItem.overall_rating) ? commentItem.overall_rating : 0);
            if (commentItem.content.length > 50) {
                commentItem.lessContent = commentItem.content.substr(0, 50) + '...';
            }
            return commentItem;
        });
        return result;
    }

    var baiduCommentView;

    var renderPage = function(commentPage, commentTpl, result) {
        var fixedData = {
            'blockNum': result.review.length
        }
        commentPage.append(commentTpl.body(fixedData));
        var commentContainers = $all('.comment-container');

        var evt = new BMapCom.EventDelegater($('#commentPageContent'));
        evt.on('addComment:tap/preventDefault', function(e) {
            BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, function(location) {
                var requestParam = {
                    "category": "mainmap",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "place_comment_edit_page",
                        "base_params": {
                            "uid": pageParamCache.uid,
                            "loc_x": location.locX,
                            "loc_y": location.locY,
                            "place_name": "scope",
                            "poi_name": pageParamCache.poiName
                        }
                    }
                };
                BMapCom.Kernel.notify('request', requestParam, function(result) {});
            });
        });


        var fixedCommentData = [];
        var review = result.review;
        review.forEach(function(reviewItem, index) {
            var result = fixComment(reviewItem);

            result.comments = result.comments.slice(0, 5);

            fixedCommentData.push(result);
        });

        BMapCom.Plugin.use('CommentView').then(function(CommentView) {
            fixedCommentData.forEach(function(fixedData, index) {
                var commentView = CommentView.instantiate(fixedData, commentContainers[index]);
                if (fixedData.name == 'baidumap') {
                    baiduCommentView = commentView;
                };
                commentView.event.on('sortByDefault', function() {
                    refreshUgc('sortByDefault');
                });
                commentView.event.on('sortByTime', function() {
                    refreshUgc('sortByTime');
                });
                commentView.event.on('seeMoreClick', function() {
                    if (fixedData.name == 'baidumap') {
                        var entranceParam = {
                            "page": "commentDetailPage",
                            "pageParam": {
                                //必传参数
                                "uid": pageParamCache.uid,
                                "poiName": pageParamCache.poiName
                            }
                        }
                        BMapCom.Kernel.notify('changePage', entranceParam);
                    } else {
                        var entranceParam = {
                            "page": "defaultWebViewPage",
                            "pageParam": {
                                "url": fixedData.url
                            }
                        }
                        BMapCom.Kernel.notify('changePage', entranceParam);
                    }
                });
            })
        });

    };

    var ugcCommentSourceDelegate = {
        search: function(uid, sort) {
            var self = this;

            var domain = "http://client.map.baidu.com/phpui2/?"
            var param = [
                'qt=ugccom',
                'resid=01',
                'maxResults=5',
                'from=webview',
                'dataformat=json',
                'orderBy=' + sort,
                'uid=' + uid
            ].join('&');
            var url = domain + param;

            return BMapCom.Loader.jsonp(url)
                .ok(function(result) {
                    self.onSourceLoadFinish(result.data, ugcCommentSource.sort);
                })
                .error(function() {
                    self.onSourceLoadFailed();
                });

        }
    };

    var ugcCommentSource = new BMapCom.DataSource();
    ugcCommentSource
        .delegate(ugcCommentSourceDelegate)
        .delegate({
            onSourceLoadFinish: function(result, sortValue) {
                baiduCommentView.clear();
                baiduCommentView.refresh(fixComment(result.review, sortValue));
                //renderPage(commentPage, commentTpl, result);
                //bindPageEvent();
            },
            startSourceLoad: function(param) {
                if (param.sort) {
                    this.sort = param.sort;
                }
                this.search(param.uid, this.sort);
            }
        });


    var refreshUgc = function(sortValue) {
        var fixedSort = 2;
        if (sortValue === 'sortByTime') {
            fixedSort = 1;
        }

        ugcCommentSource.update({
            uid: pageParamCache.uid,
            sort: fixedSort
        });
    };

    var allCommentSourceDelegate = {
        search: function(uid) {
            var self = this;

            //http://client.map.baidu.com/phpui2/?resid=01&qt=allcom&from=webview&uid=62d852adf09e449a2fb17ef5&dataformat=json
            var domain = "http://client.map.baidu.com/phpui2/?"
            var param = [
                'qt=allcom',
                'resid=01',
                'from=webview',
                'dataformat=json',
                'uid=' + uid
            ].join('&');
            var url = domain + param;


            return BMapCom.Loader.jsonp(url)
                .ok(function(result) {
                    if (result.data.phpui.errNo == 0) {
                        self.onSourceLoadFinish(result.data);
                    }
                })
                .error(function() {
                    self.onSourceLoadFailed();
                });

        }
    };

    var bindPageEvent = function() {
        var evt = new BMapCom.EventDelegater($('#imageDetailContainer'));
    };


    var initMethod = function(commentPage, commentTpl) {

        var allCommentSource = new BMapCom.DataSource();
        allCommentSource
            .delegate(allCommentSourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    if (result.review) {
                        renderPage(commentPage, commentTpl, result);
                        bindPageEvent();
                    }
                    BMapCom.Kernel.notify('webPageReady');
                },
                startSourceLoad: function(uid) {
                    this.search(uid);
                }
            });
        commentPage
            .delegate({
                shouldWaiting: function() {
                    return true;
                },
                onCreate: function(pageParam, ready) {
                    pageParamCache = pageParam;
                    allCommentSource.update(pageParam.uid);
                },
                onDestory: function() {
                    renderContainer.innerHTML = "";
                }
            });

        BMapCom.Kernel.listen('refresh', function() {
            refreshUgc();
        });

    }


    return {
        initWithPage: initMethod
    }
});