BMapCom.Controller.create(function() {

    var $ = function(q) {
        return document.querySelector(q);
    };

    var pageParamCache = {}

    var poiDetailSourceDelegate = {
        search: function(uid) {
            var self = this;

            var ERRNO_SUCCESS = 0;

            var LOCAL_STORAGE_KEY = "lsk-scenery-detail-" + uid;

            var resultData = BMapCom.storage.getLocalStorage(LOCAL_STORAGE_KEY);

            if (resultData) {
                console.log('----localStorage----')
                //命中缓存
                self.onSourceLoadFinish(resultData);
            } else {
                console.log('----request----')
                //http://client.map.baidu.com/phpui2/?t=1390199665455&qt=ninf&from=webview&resid=01&uid=62d852adf09e449a2fb17ef5
                var domain = "http://client.map.baidu.com/phpui2/?";
                //var domain = "http://10.46.139.33:8002/phpui2/?";
                //var domain = "http://10.94.23.71:8061/phpui2/?";

                var param = [
                    'qt=ninf',
                    'from=webview',
                    'resid=01',
                    'uid=' + uid
                ].join('&');

                var url = domain + param;

                return BMapCom.Loader.jsonp(url)
                    .ok(function(result) {
                        if (result.data.phpui.errNo == 0) {
                            BMapCom.storage.setLocalStorage(LOCAL_STORAGE_KEY, result.data, 5);
                            self.onSourceLoadFinish(result.data);
                        } else {
                            alert('errNo fail');
                        }

                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            }
        }
    }

    var fixData = function(content) {
        var di = {};
        var tags = [];
        if (content.ext && content.ext.detail_info) {
            di = content.ext.detail_info;
        }
        var ri = {};
        if (content.ext && content.ext.rich_info) {
            ri = content.ext.rich_info;
        }
        var strategy = content.ext ? content.ext.strategy : null;
        //console.log(content);
        var result = {
            'uid': content.uid,
            'name': content.name,
            'addr': content.addr || '',
            //'price' : di.entrance_price,
            'picNum': di.photo_num || 0,
            'level': ri.level || '',
            'headPic': di.image ? BMapCom.util.getThumbUrl(di.image, 75, 60) : 'style/img/basic-info-pic-empty.png',
            'tel': di.phone,
            'comment_num': di.comment_num,
            'travelNote': strategy
        };
        var price_reg = /.*\d+(\.\d+)?.*/;
        if (price_reg.test(di.entrance_price))
            result.price = di.entrance_price;
        if (di.overall_rating) {
            result.rating = parseFloat(di.overall_rating).toFixed(1);
        } else {
            result.rating = '';
        }
        if (di.tag) {
            tags = di.tag.split(",");
            if (tags.length > 0) {
                var match = (/A+/).exec(tags[0]);
                result.scene_level = match ? match[0].length + "A景区" : null;
                result.scene_title = (tags.slice(1)).join(",");
            }
        }
        result.descriptionOne = ri.description ? ri.description.substring(0, 50) : "";
        result.descriptionTwo = ri.description ? ri.description.substring(50) : "";
        result.openTimeOne = ri.shop_hours ? ri.shop_hours.substring(0, 50) : "";
        result.openTimeTwo = ri.shop_hours ? ri.shop_hours.substring(50) : "";
        if (content.ext && content.ext.learn_more && content.ext.learn_more.best_time)
            result.best_time = content.ext.learn_more.best_time;
        return result;
    }
    var fixCommentData = function(detailData) {
        if (!detailData.ext || !detailData.ext.review) {
            return null;
        };
        var review = detailData.ext.review;

        var result = {
            'showHead': true,
            'showSort': false,
            'showSeeMoreFoot': true,
            'showLoadMoreFoot': false,
            'title': '评论',
            'total': detailData.ext.detail_info ? detailData.ext.detail_info.comment_num : '',
            'comments': []
        }
        //评论信息
        //获取真实展示的评论数,仅展示2条，按来源顺序优先抽取，不足2条从下一组来源中获取并填充
        var showComments = [];
        var sourceIndex = 0;
        var source = review[0];
        while (showComments.length < 2 && source && source.info) {
            showComments = showComments.concat(
                source.info.slice(0, source.info.length)
                .map(function(comment) {
                    comment.cn_name = source.cn_name;
                    return comment;
                }));
            source = review[++sourceIndex];
        }
        //可能填充的数量大于2，此处一次性裁切
        showComments = showComments.slice(0, 2);
        result.comments = showComments.map(function(item) {
            item.username = item.user_name || (item.cn_name + '网友');

            item.ratingLevel = (item.rating) ? item.rating * 20 + "%" : ((item.overall_rating) ? item.overall_rating * 20 + "%" : 0);
            item.rating = (item.rating) ? item.rating : ((item.overall_rating) ? item.overall_rating : 0);

            // item.price = 230;
            if (item.content.length > 50) {
                item.lessContent = item.content.substr(0, 50) + '...';
            }
            return item;
        });
        return result;
    }
    var fixBookData = function(detailData, detailTpl) {
        if (!detailData.ext || !detailData.ext.rich_info || !detailData.ext.rich_info.scope_ticket) {
            return null;
        }

        var st = detailData.ext.rich_info.scope_ticket;

        var result = {};
        result.tickets = [];
        st.forEach(function(ticketItem) {
            var agentHTML = [];
            var length = ticketItem.agent.length;
            ticketItem.agent.forEach(function(item, index) {
                var fixedAgent = {
                    'name': item.travel_agent,
                    'price': item.price,
                    'url': item.book_url_mobile,
                    'lastFlag': (index == (length - 1)) ? 0 : 1
                };
                agentHTML.push(detailTpl.bookAgent(fixedAgent));
            })

            var ticket = {
                'name': ticketItem.name,
                'originPrice': parseInt(ticketItem.min_price) + parseInt(ticketItem.save),
                'minPrice': parseInt(ticketItem.min_price),
                'agentHTML': agentHTML.join('')
            }
            result.tickets.push(ticket);
        });
        return result;
    }

    var fixBindData = function(detailData) {
        var content = detailData.content;
        var di = {};
        if (content.ext && content.ext.detail_info) {
            di = content.ext.detail_info;
        }
        var result = {
            "uid": content.uid,
            "poiName": content.name || "",
            "tel": content.phone,
            "address": content.addr,
            'price': di.entrance_price,
            "imageUrl": di.image || "",
            "pointX": di.point ? di.point.x : "",
            "pointY": di.point ? di.point.y : "",
            "cityId": content.city_id || 0,
            'headPic': di.image ? BMapCom.util.getThumbUrl(di.image, 75, 60) : null,
            "premiumFlag": di.premium_flag || 0,
            "commentNum": di.comment_num,
            "tag": di.tag
        };
        if (di.overall_rating) {
            result.rating = parseFloat(di.overall_rating).toFixed(1);
        } else {
            result.rating = '';
        }
        return result;
    }

    var fixTravleNoteData = function(detailData) {
        var content = detailData.content;
        if (!content.ext || !content.ext.strategy)
            return null;
        var strategy = content.ext.strategy;
        var result = {
            "total_num": strategy.total_num || '',
            "total_link": strategy.total_link_mb || '',
        };
        var strategy_detail = strategy.strategy_detail;
        if (strategy_detail && strategy_detail.length > 0) {
            result.title = strategy_detail[0].title;
            var rt = strategy_detail[0].release_time.split("-");
            result.release_time = "20" + rt[0] + "-" + rt[1];
            result.link = strategy_detail[0].link_mb;
            if (strategy_detail[0].photo && strategy_detail[0].photo.length > 1)
                result.photo = strategy_detail[0].photo[1];
        }
        return result;
    };
    //渲染页面
    var renderPage = function(detailPage, detailTpl, detailData) {
        var bindData = fixBindData(detailData);

        var detail = detailData.content;

        var fixedDetailData = fixData(detailData.content);

        detailPage.append(detailTpl.body(fixedDetailData));

        $('#detailPanel').innerHTML = detailTpl.panel(fixedDetailData);

        $('#detailBasicInfo').innerHTML = detailTpl.basicInfo(fixedDetailData);

        var fixedBookData = fixBookData(detail, detailTpl);
        if (fixedBookData) {
            $('#detailBook').innerHTML = detailTpl.book(fixedBookData);
        }
        if (detail.heat_map) {
            BMapCom.Plugin.use("!./plugin/heatMap/heatMap").then(function(heatMap) {
                heatMap.instantiate(detail, $("#detailHeatMap"));
            });
        }
        if (pageParamCache.streetScape == "1") {
            BMapCom.Plugin.use('StreetscapeView').then(function(StreetscapeView) {
                var streetscapeView = StreetscapeView.instantiate(fixedDetailData, $('#detailStreetscape'));
                streetscapeView.on('streetscapeClick', function() {
                    var requestParam = {
                        "category": "mainmap",
                        "method": BMapCom.ComRequestMethod.DISPATCH,
                        "param": {
                            "target": "street_scape_page",
                            "base_params": {
                                "uid": bindData.uid,
                                "poi_name": bindData.poiName,
                                "pt_x": parseInt(bindData.pointX),
                                "pt_y": parseInt(bindData.pointY),
                                "indoor_pano": pageParamCache.indoorScape,
                                "from_source": "poi"
                            }
                        }
                    };
                    BMapCom.Kernel.notify('request', requestParam, function(result) {});

                    BMapCom.Stat.sendOnline({
                        "da_src": "scopeCompoiDetailPG.StreetScapeBt",
                        "uid": bindData.uid,
                        "da_model": "plugin_scenery"
                    });
                });
            });
        }

        $('#detailOverView').innerHTML = detailTpl.areaInfo(fixedDetailData);

        $('#detailInfo').innerHTML = detailTpl.areaDescribe(fixedDetailData);

        BMapCom.Plugin.use('SaleView').then(function(GrouponView) {
            var grouponView = GrouponView.instantiate(detail, $('#detailGroupon'));
            grouponView.on('grouponClick', function(url) {
                var entranceParam = {
                    "page": "defaultWebViewPage",
                    "pageParam": {
                        "url": url
                    }
                }
                BMapCom.Kernel.notify('changePage', entranceParam);
            });
        });

        var fixedNoteData = fixTravleNoteData(detailData);
        if (fixedNoteData) {
            $('#detailTravelNote').innerHTML = detailTpl.travelNote(fixedNoteData);
        }

        var fixedCommentData = fixCommentData(detail);
        if (fixedCommentData) {
            BMapCom.Plugin.use('CommentView').then(function(CommentView) {
                var commentView = CommentView.instantiate(fixedCommentData, $('#detailComment'));
                commentView.event.on('seeMoreClick', function() {
                    var entranceParam = {
                        "page": "commentPage",
                        "pageParam": {
                            //必传参数
                            "uid": bindData.uid,
                            "poiName": bindData.poiName
                        }
                    }
                    BMapCom.Kernel.notify('changePage', entranceParam);

                    BMapCom.Stat.sendOffline('scnd_vcmt_clk', {
                        "da_model": "plugin_scenery"
                    });
                });
            });
        }

        BMapCom.Plugin.use('NearbySearchView').then(function(NearbySearchView) {
            var nearbySearchView = NearbySearchView.instantiate(detail, $('#detailNearbySearch'));

            var nearbySearch = function(keyword) {
                var requestParam = {
                    "category": "mainmap",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "nearby_page",
                        "base_params": {
                            "poi_name": bindData.poiName,
                            "pt_x": parseInt(bindData.pointX),
                            "pt_y": parseInt(bindData.pointY),
                            "search_key": keyword
                        }
                    }
                };
                BMapCom.Kernel.notify('request', requestParam);
            };

            nearbySearchView.on('delicacyClick', function() {
                nearbySearch('美食');
                BMapCom.Stat.sendOffline('scnd_fmei_clk', {
                    "da_model": "plugin_scenery"
                });
            });
            nearbySearchView.on('snackClick', function() {
                nearbySearch('小吃');
                BMapCom.Stat.sendOffline('scnd_fxiao_clk', {
                    "da_model": "plugin_scenery"
                });
            });
            nearbySearchView.on('hotelClick', function() {
                nearbySearch('酒店');
                BMapCom.Stat.sendOffline('scnd_fjiu_clk', {
                    "da_model": "plugin_scenery"
                });
            });
            nearbySearchView.on('busClick', function() {
                nearbySearch('公交');
                BMapCom.Stat.sendOffline('scnd_fstop_clk', {
                    "da_model": "plugin_scenery"
                });
            });
            nearbySearchView.on('moreClick', function() {
                nearbySearch('更多');
                BMapCom.Stat.sendOffline('scnd_fmore_clk', {
                    "da_model": "plugin_scenery"
                });
            });
            nearbySearchView.on('moreSourceClick', function(url) {
                var entranceParam = {
                    "page": "defaultWebViewPage",
                    "pageParam": {
                        "url": url
                    }
                }
                BMapCom.Kernel.notify('changePage', entranceParam);
            });
        });

        BMapCom.Plugin.use('ShareView').then(function(ShareView) {
            var shareView = ShareView.instantiate(detail, $('#detailShare'));

            shareView.on('shareClick', function() {
                var requestParam = {
                    "category": "mainmap",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "poi_share",
                        "base_params": {
                            "uid": bindData.uid,
                            "poi_name": bindData.poiName,
                            "poi_tel": bindData.tel,
                            "poi_addr": bindData.address,
                            "pt_x": parseInt(bindData.pointX),
                            "pt_y": parseInt(bindData.pointY),
                            "poi_img_url": bindData.imageUrl
                        }
                    }
                };
                BMapCom.Kernel.notify('request', requestParam, function(result) {});

                BMapCom.Stat.sendOffline('scnd_share_clk', {
                    "da_model": "plugin_scenery"
                });
            });
        });

        //初始化Widget
        var widgetParam = {
            "uid": bindData.uid,
            "poi_name": bindData.poiName,
            "poi_addr": bindData.address,
            "poi_tel": bindData.tel,
            //PoiType:0为普通点
            "poi_type": 0,
            "pt_x": parseInt(bindData.pointX),
            "pt_y": parseInt(bindData.pointY),
            "city_id": bindData.cityId,
            "deep_detail": {
                "src_name": "scope",
                "overall_rating": bindData.rating,
                "image": bindData.imageUrl,
                "price": bindData.price,
                "tag": bindData.tag,
                "premium_flag": bindData.premiumFlag,
                "comment_num": bindData.commentNum
            }
        };
        if (pageParamCache.option && pageParamCache.option.index) {
            widgetParam.index = pageParamCache.option.index;
        }
        //Header
        BMapCom.Kernel.notify('widget', {
            "wid": "poi_detail_header",
            "method": "init",
            "param": widgetParam
        });
        //Footer
        BMapCom.Kernel.notify('widget', {
            "wid": "poi_detail_footer",
            "method": "init",
            "param": widgetParam
        });
    }

    var bindPageEvent = function(detailData) {
        var bindData = fixBindData(detailData);

        var evt = new BMapCom.EventDelegater($('#detailContainer'));

        evt.on('nearbyBtn:tap', function(e) {
            var requestParam = {
                "category": "mainmap",
                "method": BMapCom.ComRequestMethod.DISPATCH,
                "param": {
                    "target": "nearby_page",
                    "base_params": {
                        "poi_name": bindData.poiName,
                        "pt_x": parseInt(bindData.pointX),
                        "pt_y": parseInt(bindData.pointY)
                    }
                }
            };
            BMapCom.Kernel.notify('request', requestParam);

            BMapCom.Stat.sendOffline('scnd_find_clk', {
                "da_model": "plugin_scenery"
            });
        });


        evt.on('gotoBtn:tap', function(e) {
            BMapCom.SysApi.getRuntimeInfo([BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID], function(runtimeInfo) {
                var requestParam = {
                    "category": "mainmap",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "route_search_page",
                        "base_params": {
                            "start_type": 1,
                            "start_keyword": "我的位置",
                            "start_longitude": runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locX,
                            "start_latitude": runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locY,
                            "start_city_id": runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID],
                            "end_type": 1,
                            "end_keyword": bindData.poiName,
                            "end_longitude": parseInt(bindData.pointX),
                            "end_latitude": parseInt(bindData.pointY),
                            "end_uid": pageParamCache.uid,
                            "end_city_id": bindData.cityId
                        }
                    }
                };
                BMapCom.Kernel.notify('request', requestParam);

                BMapCom.Stat.sendOffline('scnd_go_clk', {
                    "da_model": "plugin_scenery"
                });
            });

        });
        evt.on('telBtn:tap', function(e) {
            var phoneNum = this.getAttribute('data-value');
            BMapCom.SysApi.tel(phoneNum);

            BMapCom.Stat.sendOffline('scnd_tel_clk', {
                "da_model": "plugin_scenery"
            });
        });

        evt.on('basicInfoPic:tap', function(e) {
            if (bindData.headPic) {
                //若有照片，则进入图片页
                var entranceParam = {
                    "page": "imagePage",
                    "pageParam": {
                        //必传参数
                        "uid": bindData.uid,
                    }
                }
                BMapCom.Kernel.notify('changePage', entranceParam);
            } else {
                //若无照片，进入上传图片页
                BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS, function(bduss) {
                    var requestParam = {
                        "category": "mainmap",
                        "method": BMapCom.ComRequestMethod.DISPATCH,
                        "param": {
                            "target": "upload_photo_page",
                            "base_params": {
                                "user_bduss": bduss,
                                "place_type": "scope",
                                "uid": bindData.uid
                            }
                        }
                    };
                    BMapCom.Kernel.notify('request', requestParam, function(result) {});
                });
            }
        });

        evt.on('areaInfoMore:tap', function(e) {
            var visibility = this.getAttribute('data-value');
            var node = $('#areaInfoMore');
            if (visibility === 'show') {
                this.setAttribute('data-value', 'hidden');
                this.className = 'base-down-icon area-info-more-btn';
                node.className = 'area-info-more-hidden';
            } else {
                this.setAttribute('data-value', 'show');
                this.className = 'base-up-icon area-info-more-btn';
                node.className = 'area-info-more-show';

                BMapCom.Stat.sendOffline('scnd_minfo_clk', {
                    "da_model": "plugin_scenery"
                });
            }
        });

        evt.on('getopInfo:tap', function(e) {
            var openTimeMore = $("#opInfoMore");
            var show = openTimeMore.getAttribute("show");
            var cn = this.className;
            if (show == "off") {
                openTimeMore.setAttribute("show", "on");
                openTimeMore.style.display = "inline";
                this.className = cn.replace(/areaDescribe-arrow-down/i, "areaDescribe-arrow-up");
            } else {
                openTimeMore.setAttribute("show", "off");
                openTimeMore.style.display = "none";
                this.className = cn.replace(/areaDescribe-arrow-up/i, "areaDescribe-arrow-down");
            }
        });

        evt.on('operateBtn:tap', function(e) {
            var dataValue = (this.getAttribute('data-value')).split('-');
            var status = dataValue[0];
            var index = dataValue[1];

            var agentList = $('#bookTicketItemAgent' + index);
            var cn = this.className;
            if (status === 'up') {
                this.setAttribute('data-value', 'down-' + index);
                agentList.style.display = 'block';
                this.className = cn.replace(/book-operate-btn-up/i, "book-operate-btn-down");

            } else {
                this.setAttribute('data-value', 'up-' + index);
                agentList.style.display = 'none';
                this.className = cn.replace(/book-operate-btn-down/i, "book-operate-btn-up");
            }
        });

        evt.on('bookBtn:tap', function(e) {
            var url = this.getAttribute('data-value');
            var entranceParam = {
                "page": "defaultWebViewPage",
                "pageParam": {
                    "url": url
                }
            }
            BMapCom.Kernel.notify('changePage', entranceParam);

            BMapCom.Stat.sendOnline({
                "da_src": "scopeCompoiDetailPG.orderOnlineBt",
                "da_model": "plugin_scenery",
                "dt_act": "click",
                "da_trd": "scope"
            });
        });

        evt.on('SeeMoreOverview:tap', function(e) {
            var moreDescribe = $("#areaDescribeMore");
            if (moreDescribe.getAttribute("show") == "on") {
                moreDescribe.style.display = "none";
                $(".overviewDescribe-arrow").className = "overviewDescribe-arrow overviewDescribe-arrow-down";
                moreDescribe.setAttribute("show", "off");
            } else {
                moreDescribe.style.display = "inline";
                $(".overviewDescribe-arrow").className = "overviewDescribe-arrow overviewDescribe-arrow-up";
                moreDescribe.setAttribute("show", "on");
            }
        });

        evt.on('seeMoreNote:tap', function(e) {
            var url = this.getAttribute("data-value");
            var entranceParam = {
                "page": "defaultWebViewPage",
                "pageParam": {
                    "url": url
                }
            };
            BMapCom.Kernel.notify('changePage', entranceParam);
        });

    }

    var renderReady = null;
    var initMethod = function(detailPage, detailTpl) {
        var poiDetailSource = new BMapCom.DataSource();
        //绑定数据对象代理
        poiDetailSource
            .delegate(poiDetailSourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    renderPage(detailPage, detailTpl, result);
                    bindPageEvent(result);
                    renderReady && renderReady();
                    BMapCom.Kernel.notify('webPageReady');
                },
                startSourceLoad: function(uid) {
                    this.search(uid);
                }
            });
        //绑定页面事件代理
        detailPage
            .delegate({
                shouldWaiting: function() {
                    return true;
                },
                onCreate: function(pageParam, ready) {
                    renderReady = ready;
                    pageParamCache = pageParam;
                    poiDetailSource.update(pageParam.uid);
                },
                onDestory: function() {
                    renderContainer.innerHTML = "";
                    // this.destoryDomCache();
                }
            });

    }
    return {
        initWithPage: initMethod
    }
});