BMapCom.Template.create("./plugin/DateView/DateViewTpl", {
header:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,lArrow=$data.lArrow,rArrow=$data.rArrow,year=$data.year,month=$data.month,$out='';$out+='<div class="dv-title">\n        <div class="dv-title-prev ';
$out+=$escape(lArrow);
$out+='" data-ek="prevMonth"></div>\n            <div class="dv-title-next ';
$out+=$escape(rArrow);
$out+='" data-ek="nextMonth"></div>\n            <div class="dv-title-text">';
$out+=$escape(year);
$out+='年';
$out+=$escape(month);
$out+='月</div>\n        </div>';
return new String($out);
},
weekTitle:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,$out='';$out+='<tr>\n            <th>日</th>\n            <th>一</th>\n            <th>二</th>\n            <th>三</th>\n            <th>四</th>\n            <th>五</th>\n            <th>六</th>\n        </tr>';
return new String($out);
},
day:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,value=$data.value,className=$data.className,text=$data.text,$out='';$out+='<td data-ek="day" value="';
$out+=$escape(value);
$out+='" class="';
$out+=$escape(className);
$out+='">';
$out+=$escape(text);
$out+='</td>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
    var getDays = function(year, month){
        //计算机的月份表达式为0-11，
        //使用的是1-12月份的计算方式，故这里传入的month要+1
        month += 1;
        switch (month){
            case 4:
            case 6:
            case 9:
            case 11:
                return 30;
            case 2:
                //yep,this code won't be alive till that time,so 'somehow'
              //optimize here
                return (year % 4 == 0)? 29 : 28;
            default:
                return 31;
        }
    }
    
    var formatDateToNumber = function(date){
        //return date ? (date.getFullYear() * 10000 + date.getMonth() * 100 + date.getDate()) : null;
        return date ? (date.getFullYear() + "-" +
                       ( hotelUtil.standardDate(date.getMonth()+1) ) + "-" + 
                       ( hotelUtil.standardDate(date.getDate()) )) : null;
    }

    var sdkStyle = {
        'STAR':'c-star',
        'RED_STAR':'c-red-star',
        'DEFAULT_USER_HEAD':'c-default-user-head',
        'DOWN_ARROW':'c-down-arrow',
        'DRAG_BALL':'c-drag-ball',
        'GO_TO_ICON':'c-goto-icon',
        'NEARBY_ICON':'c-nearby-icon',
        'TEL_ICON':'c-tel-icon',
        'GROUPON_ICON':'c-groupon-icon',
        'FAVORABLE_ICON':'c-favorable-icon',
        'STREETSCAPE_ICON':'c-streetscape-icon',
        'SHARE_ICON':'c-share-icon',
        'WIFI_ICON':'c-wifi-icon',
        'BROAD_ICON':'c-broad-icon',
        'STOP_ICON':'c-stop-icon',
        'DINING_ICON':'c-dining-icon',
        'GYM_ICON':'c-gym-icon',
        'POOL_ICON':'c-pool-icon',
        'MEETING_ICON':'c-meeting-icon',
        'BUSINESS_ICON':'c-business-icon',
        'LEFT_ARROW_ICON':'c-left-arrow-icon',
        'RIGHT_ARROW_ICON':'c-right-arrow-icon',
        'UPLOAD_PIC_ICON':'c-upload-pic-icon',
        'PULL_DOWN_ICON':'c-pull-icon-down',
        'PULL_UP_ICON':'c-pull-icon-up',
        'PAGER_LEFT_ICON':'c-pager-left-icon',
        'PAGER_RIGHT_ICON':'c-pager-right-icon',
        'WRITE_ICON':'c-write-icon',
        'RIGHT_ARROW':'c-right-arrow',
        'DROP_DOWN_ARROW':'c-dropDown-arrow',
        'DROP_DOWN_HIGHLIGHT_ARROW':'c-dropDown-highlight-arrow',
        'DROP_DOWN_SELECTED':'c-dropDown-selected',
        'NO_DATA':'c-nodata'
    };


    var today = new Date();
    var DEFAULT = {
        parent: document.body, //显示日历的元素，默认插入body
        today: new Date(),
        selected:new Date(),
        // count: 1,      //显示月份的个数
        selectRange:[new Date(today), new Date(today.getFullYear(), today.getMonth(), today.getDate() + 89)], //可以选择日期的区间
        input: null, //绑定input
        // position: this.G(options.position), //判断日历应该显示的位置
        // onStart: options.onStart || f, //初始化完成回调
        // onShow: options.onShow || f, //显示时调用
        // onHide: options.onHide || f, //隐藏时调用
        // onSelectDay: options.onSelectDay || f, //选择日期时调用
        // onChange: options.onChange || f, //日期有变化的时候调用
        // toInput: options.toInput, //如用户自定义toInput函数，则不会执行默认的this.toInput,参数(date,week)
        // formInput: options.formInput //自定义fromInput，参数为input
    }

    var CONFIG = {
        day_text: ['日', '一', '二', '三', '四', '五', '六'], //周几
        cal_text: ['年', '月', '日'], //年月日
        cal_class: 'op_cal', //最外层结点className
        month_class_pre: 'op_mon_pre', //每个月份的日历className前缀
        month_class: 'op_mon', //月份className
        day_class: ['op_mon_pre_month', 'op_mon_cur_month', 'op_mon_next_month', 'op_mon_today', 'op_mon_day_hover', 'op_mon_day_selected', 'op_mon_day_disabled'], //上月、本月、下月、今天、鼠标移上、选中、不可选状态的className
        btn_class: ['op_btn_pre_month', 'op_btn_next_month'] //按钮的className
    };
    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS:true
    });
    var DateView = function(params,context,plg){
      var dateView =  {
        refresh:function(){
            var date = this._date;
            var year = date.getFullYear();
            var month = date.getMonth();
            var day = date.getDate();
            var showDays = [];
            //本月有多少天
            var dayCount = getDays(year, month);
            for(var i = 1; i <= dayCount; i++){
                showDays.push({
                    'value':formatDateToNumber(new Date(year, month, i)),
                    'text':i
                });
            }
            //补月初
            //本月1号是周几 0 - 6
            var firstDayOfMonth = (new Date(year, month, 1)).getDay(); 
            //如果是非周一，则需要从前一月补充日期，补充的天数即为星期几
            var prevMonthDayCount = getDays(year, month - 1);
            while(firstDayOfMonth > 0){
                showDays.unshift({
                    'value':formatDateToNumber(new Date(year, month-1, prevMonthDayCount)),
                    'text':prevMonthDayCount
                });
                prevMonthDayCount--;
                firstDayOfMonth--;
            }
            //补月末
            //本月最后一天是周几
            var lastDayOfMonth = (new Date(year, month, dayCount)).getDay(); 
            //如果是非周日，则需要从下个月补充日期，补充的天数即为 6 - 星期
            var nextMonthDayCount = 1;
            while(lastDayOfMonth < 6){
                // showDays.push(nextMonthDayCount++);
                // lastDayOfMonth++;
                showDays.push({
                    'value':formatDateToNumber(new Date(year, month+1, nextMonthDayCount)),
                    'text':nextMonthDayCount
                });
                nextMonthDayCount++;
                lastDayOfMonth++;
            }


            var html = [plg.template.header({
                'lArrow':sdkStyle.LEFT_ARROW_ICON,
                'rArrow':sdkStyle.RIGHT_ARROW_ICON,
                'year':year,
                'month':month + 1
            })];

            var dateTable = ['<table class="dv-table-content">'];
            dateTable.push(plg.template.weekTitle());

            var range = this.options.selectRange || [];

            var beginDayNumber = formatDateToNumber(range[0]);
            var endDayNumber = formatDateToNumber(range[1]);
            var TODAY = this.options._todayData;
            var weekDays = [];
            var selectedDayNumber = formatDateToNumber(this.options.selected);
            var isOutOfRangeFunc = function(val,begin,end){
                val = hotelUtil.standarDateToNum(val);
                end = hotelUtil.standarDateToNum(end);
                begin = hotelUtil.standarDateToNum(begin);
                return (begin && val < begin) || (end && val > end);
            }
            showDays.forEach(function(day, index){
                //var monthOfDay = (day.value + '').substr(4, 2) * 1;
                var monthOfDay = parseInt(day.value.split("-")[1],10) - 1;
                var isDisable = false;
                //是否超出了时间范围
                //var isOutOfRange = (beginDayNumber && day.value < beginDayNumber) ||
                //                    (endDayNumber && day.value > endDayNumber);
                var isOutOfRange = isOutOfRangeFunc(day.value,beginDayNumber,endDayNumber);
                var className = "";
                if(day.value === TODAY.number){
                    //今天
                    className = 'dv-day-today';
                }else if(day.value === selectedDayNumber){
                    //当前选中的
                    className = 'dv-day-selected';
                }else if(monthOfDay !== month){
                    //非本月的
                    className = 'dv-day-otherMonth';
                }
                className = isOutOfRange ? "dv-day-disable" : className;


                if(index % 7 == 0){
                    //每行首元素
                    weekDays = ['<tr>'];
                }
                weekDays.push(plg.template.day({
                    'className':className,
                    'text':day.text,
                    'value':isOutOfRange ? "" : day.value
                }));
                if(index % 7 == 6){
                    //每行末元素
                    weekDays.push('</tr>');
                    dateTable.push(weekDays.join(''));
                }
            });
            dateTable.push('</table>');
            html.push(dateTable.join(''));
            this.container.innerHTML = html.join('');
            return this;
            },
            setDate:function(date){
                this._date = date;
                this.refresh();
            },
            setSelectRange:function(begin, end){
                this.options.selectRange = [begin, end];
                this.refresh();
            },
            prevMonth:function(){
                var d = this._date;
                d.setMonth(d.getMonth() - 1);
                this.refresh();
                return this
            },
            nextMonth:function(){
                var d = this._date;
                d.setMonth(d.getMonth() + 1);
                this.refresh();
                return this;
            },
            show:function(flag){
                this.editFlag = flag
                this.refresh();
                this.container.style.display = '';
            },
            hide:function(){
                this.container.style.display = 'none';
            },
            getDate:function(){
                return this._date;
            },
            setPosition:function(x, y){
                if(x || x == 0){
                    this.container.style.left = x + 'px';
                }
                if(y || y == 0){
                    this.container.style.top = y + 'px';
                }
            },
            setStartTime:function(startTime){
                this.startTime = startTime;
            },
            setEndTime : function(endTime){
                this.endTime = endTime;
            },
            initialize:function(params,context) {
                var self = this;
                this.options =hotelUtil.fill(params, DEFAULT);
                this.container = context;
                var dispatcher = new BMapCom.EventDispatcher();
                this.dispatcher = dispatcher;
                this.options._todayData = {
                    'year':this.options.today.getFullYear(),
                    'month':this.options.today.getMonth(),
                    'day':this.options.today.getDate(),
                    'number':formatDateToNumber(this.options.today)
                };
                this.startTime = hotelUtil.formatDate(new Date());
                this.endTime = hotelUtil.formatDate(new Date(),1);
                this.container.setAttribute('data-role', 'dateView');
                this.container.className = 'dv-container';

                var domEventController = new BMapCom.EventDelegater(context);
                domEventController.on('prevMonth:tap', function(){
                    self.prevMonth();
                });
                domEventController.on('nextMonth:tap', function(){
                    self.nextMonth();
                });
                var selectedDayElem = null;
                var selectedDayElemClassName = null;
                var Flag = {
                    begin:1,
                    end:2
                };
                var self = this;
                domEventController.on('day:tap', function(){
                    var value = this.getAttribute('value'),
                        startTime ,endTime;
                    if(!value){
                        return;
                    }
                    if(selectedDayElem){
                        //还原之前的className
                        selectedDayElem.className = selectedDayElemClassName;
                    }
                    if(self.editFlag == Flag.begin){
                      self.startTime = value;
                      var newEndTime = hotelUtil.formatDate( new Date(self.startTime),1);
                      self.endTime = newEndTime;
                    }
                    else if(self.editFlag == Flag.end){
                      self.endTime = value;
                    }
                    //保存当前的并改写为选中态
                    selectedDayElemClassName = this.className;
                    selectedDayElem = this;
                    selectedDayElem.className = 'dv-day-selected';
                    self.hide();
                    dispatcher.fire('dayChange',[self.startTime,self.endTime]);
                });
                this.hide();
            }
          };
          return dateView;
    };
    plg.delegate({
        onInstantiate: function(params,context) {
            var dateView = new DateView(params,context,plg);
            dateView.initialize(params,context);
            return dateView;
        }
    });
    return plg;
});

