var hotelUtil = {
    initWidget:function(bindData,pageParamCache){
        //初始化Widget,Copy from scenery
        var widgetParam = {
            "uid": bindData.uid,
            "poi_name": bindData.poiName,
            "poi_addr": bindData.address,
            "poi_tel": bindData.tel,
            //PoiType:0为普通点
            "poi_type": 0,
            "pt_x": parseInt(bindData.pointX),
            "pt_y": parseInt(bindData.pointY),
            "city_id": bindData.cityId,
            "deep_detail": {
                "src_name": "scope",
                "overall_rating": bindData.rating,
                "image": bindData.imageUrl,
                "price": bindData.price,
                "tag": bindData.tag,
                "premium_flag": bindData.premiumFlag,
                "comment_num": bindData.commentNum
            }
        },
            emptyFunc = function(){};
        if (pageParamCache.option && pageParamCache.option.index) {
            widgetParam.index = pageParamCache.option.index;
        }
        //Header
        BMapCom.Kernel.notify('widget', {
            "wid": "poi_detail_header",
            "method": "init",
            "param": widgetParam
        }, emptyFunc);
        //Footer
        BMapCom.Kernel.notify('widget', {
            "wid": "poi_detail_footer",
            "method": "init",
            "param": widgetParam
        }, emptyFunc);
    },
	fill: function(obj, defaultObj) {
			if (!obj) {
				return defaultObj;
			}
			var result = {};
			for (var k in defaultObj) {
				result[k] = (k in obj) ? obj[k] : defaultObj[k];
			}
			return result;
		},
    getParentElemWith:function(currentElem,config){
      var body = document.body;
      function _consider(elem){
          for(var attr in config){
              if(elem.getAttribute(attr) != config[attr]){
                return false;
              }
          }
          return true;
      }
      while(currentElem != body){
         if( _consider(currentElem)){
            return currentElem;
         }
         else{
            currentElem = currentElem.parentNode; 
         }
      }
      return false;
    },
    //note that there's a huge performance issue
    //but with a nicer syntax
    valueForKeyPath:function(obj,path){
       if(!path) return null;
       var func = new Function("dataObj",
                "var result;"+
                "with(dataObj){" + 
                    "try{"+
                        "result = " + path + ";" +
                   "}"+
                    "catch(e){"+
                      "return null;"+
                    "}"+
                "};"+
                "return result;"
               );
       return func(obj,path);
    },
    stringToDate:function(str){
      return new Date(str);
    },
    standardDate : function(num){
        return ("0" + num ).slice(-2);
    },
    standarDateToNum:function(str){
        return parseInt(str.replace(/-/g,""),10);
    },
    formatDate : function(date, addDay, addMonth) {
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var day = date.getDate();
        var daysInMonth = function(m){
              switch(m){
                  case 4:
                  case 6:
                  case 9:
                  case 11:
                      return 30;
                  case 2:
                      //yep,this code won't be alive till that time,so 'somehow'
                    //optimize here
                      return (year % 4 == 0)? 29 : 28;
                  default:
                      return 31;
              }
        }
        var days = daysInMonth(month);
        if(addDay){
            if(day + addDay <= days){
                day = day + addDay
            }
            else{
              //[bug]there's a bug here
                month++;
                day = addDay
            }
        }
        /*
        var d = [
            date.getFullYear(),
            ("0" + (date.getMonth() + 1 + (addMonth ? addMonth : 0))).slice(-2), //getMonth是0-11，
            date.getDate() + (addDay ? addDay : 0),
        ].join('-');
        */
        var d = [
            date.getFullYear(),
            hotelUtil.standardDate(month),
            hotelUtil.standardDate(day)
        ].join("-");
        return d;
    },
  //[REUSE]
  formatData: function(detail) {
          var result = {};
          var c = detail.content;
          if(!c.ext){
              return;
          }
          var di = c.ext.detail_info;
					result.uid = c.uid;
					result.name = c.name;

					switch (di.wise_hotel_type) {
						case 1:
						case '1':
							//特价酒店，实时报价
							if (di.wise_low_price) {
								result.realtimePrice = di.wise_low_price;
							}
							break;
						case 2:
						case '2':
							//团购
							if (di.wise_price && di.wise_low_price) {
								result.grouponInfo = {
									'grouponPrice': di.wise_low_price,
									'basePrice': di.wise_price
								};
							}
							break;
						case 0:
						default:
							//一般酒店
							if (di.wise_price) {
								result.regularPrice = di.wise_price;
							}
					}
					result.gotoIcon = hotelConfig.sdkStyle.GO_TO_ICON;
					result.nearbyIcon = hotelConfig.sdkStyle.NEARBY_ICON;
					result.telIcon = hotelConfig.sdkStyle.TEL_ICON;
                    if(c.ext.detail_info.image){
					    result.image = BMapCom.util.getThumbUrl(c.ext.detail_info.image, 73, 58, 'center');
                    }
                    else{
                        result.image = "";
                    }
					result.image_num = c.ext.detail_info.image_num;
					result.overall_rating = c.ext.detail_info.overall_rating;
					result.category = c.ext.rich_info.category;
					result.environment_exterior = c.ext.rich_info.environment_exterior;
					result.level = c.ext.rich_info.level;
					result.addr = c.addr;
					result.phone = c.phone;
					result.city_id = c.city_id;
					result.comment_num = di.comment_num;
					result.price = di.price;
					result.premium_flag = di.premium_flag;
					result.tag = di.tag;
					result.src_name = c.ext.src_name;

					//获取真实展示的评论数,仅展示5条，按来源顺序优先抽取，不足5条从下一组来源中获取并填充
					var showComments = [];
					var sourceIndex = 0;
					var source = c.ext.review[sourceIndex];

					while (showComments.length < 5 && source && source.info) {
						showComments = showComments.concat(
							source.info.slice(0, source.info.length)
							.map(function(comment) {
								comment.cn_name = source.cn_name;
								return comment;
							}));
						source = c.ext.review[++sourceIndex];
					}
					//可能填充的数量大于5，此处一次性裁切
					showComments = showComments.slice(0, 5);
					// result.comments = showComments;

					//评论信息
					result.comments = showComments.map(function(item) {
						item.username = item.user_name || (item.cn_name + '网友');
						// item.overall_rating = item.overall_rating || 3;
						item.defaultUserHead = hotelConfig.sdkStyle.DEFAULT_USER_HEAD;
						item.starClass = hotelConfig.sdkStyle.STAR;
						item.redStarClass = hotelConfig.sdkStyle.RED_STAR;
						item.ratingLevel = (item.overall_rating || 0) * 20 + "%";
						// item.price = 230;
						if (item.content.length > 55) {
							item.lessContent = item.content.substr(0, 55) + '...';
						}
						return item;
					});

					//团购信息
					result.groupon = di.groupon;
					result.groupon_num = di.groupon_num;
					if (di.groupon && di.groupon[0]) {
						result.grouponUrl = di.groupon[0].groupon_url_mobile;
					}

					//坐标
					result.point = di.point;

					//优惠信息
					result.favorable = di.premium2;
					if (result.favorable) {
						result.favorable_num = result.favorable.length;
					}

					//酒店richinfo
					//连锁类型
					result.brand = c.ext.rich_info.brand;

					//订房电话
					var book_number = di && di.ota_info && (di.ota_info.length > 0) && di.ota_info[0].ota_phone || '';
					if (book_number) {
						result.bookNumber = book_number;
					}


					//酒店设施
					// di.special_service = "1 2 3 4 5 6 7 8";
					if (di.special_service) {
						result.hotel_facility = di.special_service.split(' ').map(function(supportIndex) {
							var d = hotelConfig.HOTEL_SERVICE[parseInt(supportIndex) - 1];
							return d;
						});
					} else {
						result.hotel_facility = [];
					}
					//房间设施
					result.inner_facility = c.ext.rich_info.inner_facility;
					//付款方式
					result.payment_type = c.ext.rich_info.payment_type;
					//周边环境
					result.environment_exterior = c.ext.rich_info.environment_exterior;

					//更多来源
					result.moreSourceInfo = di.link;
					return result;
				},

	fixBindData: function(detailData) {
					var content = detailData.content;
					var di = {};
					if (content.ext && content.ext.detail_info) {
							di = content.ext.detail_info;
					}
					var result = {
							"uid": content.uid,
							"poiName": content.name || "",
							"tel": content.phone,
							"address": content.addr,
							'price': di.entrance_price,
							"imageUrl": di.image || "",
							"pointX": di.point ? di.point.x : "",
							"pointY": di.point ? di.point.y : "",
							"cityId": content.city_id || 0,
							"premiumFlag": di.premium_flag || 0,
							"commentNum": di.comment_num,
							"tag": di.tag
					};
					if (di.overall_rating) {
							result.rating = parseFloat(di.overall_rating).toFixed(1);
					} else {
							result.rating = '';
					}
					return result;
	},

	fixCommentData: function(detailData) {
				        if (!detailData.content.ext || !detailData.content.ext.review) {
				            return null;
				        };
				        var review = detailData.content.ext.review;

				        var result = {
				            'showHead': true,
				            'showSort': false,
				            'showSeeMoreFoot': true,
				            'showLoadMoreFoot': false,
				            'title': '评论',
				            'comments': []
				        }
				        result['total'] = 0;
				        for(var i = 0; i < review.length; i++)
				        	result['total'] += parseInt(review[i].review_num);
				        //评论信息
				        //获取真实展示的评论数,仅展示5条，按来源顺序优先抽取，不足5条从下一组来源中获取并填充
				        var showComments = [];
				        var sourceIndex = 0;
				        var source = review[0];
				        while (showComments.length < 5 && source && source.info) {
				            showComments = showComments.concat(
				                source.info.slice(0, source.info.length)
				                .map(function(comment) {
				                    comment.cn_name = source.cn_name;
				                    return comment;
				                }));
				            source = review[++sourceIndex];
				        }
				        //可能填充的数量大于5，此处一次性裁切
				        showComments = showComments.slice(0, 5);
				        result.comments = showComments.map(function(item) {
				            item.username = item.user_name || (item.cn_name + '网友');
				            // item.overall_rating = item.overall_rating || 3;
				            // item.defaultUserHead = sdkStyle.DEFAULT_USER_HEAD;
				            // item.starClass = sdkStyle.STAR;
				            // item.redStarClass = sdkStyle.RED_STAR;
				            item.ratingLevel = item.overall_rating ? (item.overall_rating * 20 + "%") : null;
				            if (item.content.length > 50) {
				                item.lessContent = item.content.substr(0, 50) + '...';
				            }
				            return item;
				        });
				        return result;
    }
};

var hotelConfig = {
		sdkStyle : {
				'STAR':'c-star',
				'RED_STAR':'c-red-star',
				'DEFAULT_USER_HEAD':'c-default-user-head',
				'DOWN_ARROW':'c-down-arrow',
				'DRAG_BALL':'c-drag-ball',
				'GO_TO_ICON':'c-goto-icon',
				'NEARBY_ICON':'c-nearby-icon',
				'TEL_ICON':'c-tel-icon',
				'GROUPON_ICON':'c-groupon-icon',
				'FAVORABLE_ICON':'c-favorable-icon',
				'STREETSCAPE_ICON':'c-streetscape-icon',
				'SHARE_ICON':'c-share-icon',
				'WIFI_ICON':'c-wifi-icon',
				'BROAD_ICON':'c-broad-icon',
				'STOP_ICON':'c-stop-icon',
				'DINING_ICON':'c-dining-icon',
				'GYM_ICON':'c-gym-icon',
				'POOL_ICON':'c-pool-icon',
				'MEETING_ICON':'c-meeting-icon',
				'BUSINESS_ICON':'c-business-icon',
				'LEFT_ARROW_ICON':'c-left-arrow-icon',
				'RIGHT_ARROW_ICON':'c-right-arrow-icon',
				'UPLOAD_PIC_ICON':'c-upload-pic-icon',
				'PULL_DOWN_ICON':'c-pull-icon-down',
				'PULL_UP_ICON':'c-pull-icon-up',
				'PAGER_LEFT_ICON':'c-pager-left-icon',
				'PAGER_RIGHT_ICON':'c-pager-right-icon',
				'WRITE_ICON':'c-write-icon',
				'RIGHT_ARROW':'c-right-arrow',
				'DROP_DOWN_ARROW':'c-dropDown-arrow',
				'DROP_DOWN_HIGHLIGHT_ARROW':'c-dropDown-highlight-arrow',
				'DROP_DOWN_SELECTED':'c-dropDown-selected',
				'NO_DATA':'c-nodata'
		},
    TAB_WIDTH: "33.33%",
    LOCAL_STORAGE_KEY_PREFIX : "lsk-hotel-detail-",
    HOTEL_WISE_REQUEST_URL : "http://map.baidu.com/detail?",
    NINF_REQUEST_URL : "http://client.map.baidu.com/phpui2/?",
    devMode : 0
};

		 hotelConfig.HOTEL_SERVICE = [{
					text: 'WIFI',
					flag: 'hotel_wifi',
					iconClass: hotelConfig.sdkStyle.WIFI_ICON
				}, {
					text: '宽带',
					flag: 'hotel_broad',
					iconClass: hotelConfig.sdkStyle.BROAD_ICON
				}, {
					text: '停车',
					flag: 'hotel_stop',
					iconClass: hotelConfig.sdkStyle.STOP_ICON
				}, {
					text: '餐厅',
					flag: 'hotel_dining',
					iconClass: hotelConfig.sdkStyle.DINING_ICON
				}, {
					text: '健身房',
					flag: 'hotel_gym',
					iconClass: hotelConfig.sdkStyle.GYM_ICON
				}, {
					text: '游泳池',
					flag: 'hotel_pool',
					iconClass: hotelConfig.sdkStyle.POOL_ICON
				}, {
					text: '会议室',
					flag: 'hotel_room',
					iconClass: hotelConfig.sdkStyle.MEETING_ICON
				}, {
					text: '商务',
					flag: 'hotel_business',
					iconClass: hotelConfig.sdkStyle.BUSINESS_ICON
		}]
